;; Copyright 2011, 2013, 2014 Kevin Ryde.

;; This file is part of weblint-el.
;;
;; weblint-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; weblint-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with weblint-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))


;;-----------------

(let ((tempfile "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads "../compilation-weblint.el")
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))


compilation-error-regexp-alist

(let ((str "aaa"))
  (string-match "\\(a+?\\)" str)
  (match-string 1 str))

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (eval-after-load "compile" '(require 'compilation-weblint))
  (compile "echo t-compilation-weblint.html:3:5: blah"))

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (eval-after-load "compile" '(require 'compilation-weblint))
  (compile "echo 't-compilation-weblint.html(3:5) : informational blah'"))

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (eval-after-load "compile" '(require 'compilation-weblint))
  (compile "echo 't-compilation-weblint.html (3:5) : informational blah'"))

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (eval-after-load "compile" '(require 'compilation-weblint))
  (compile "echo 'Warning W1022 t-compilation-weblint.html 5: Call to function 'func' with no prototype'"))


(progn
  (looking-at "\\([^( \n\t]+\\)(\\([0-9]+\\):\\([0-9]+\\)) : ")
  (match-string 1))
t-compilation-weblint.html(3:5) : informational blah

(let ((n 0))
  (require 'compile)
  (dolist (elem compilation-error-regexp-alist)
    (setq n (1+ n))
    (if (looking-at (car elem))
	(message "%s  %s" n elem)))
  (switch-to-buffer (or (get-buffer "*Messages*")
			(get-buffer " *Message-Log*")))
t-compilation-weblint.html (3:5) : informational blah






;;-----------------------------------------------------------------------------
;; unused

(defun weblint-switch-to-buffer-other-window (buffer)
  "Switch to display BUFFER in another window.
If it wasn't already in a window then the window is shrunk with
`shrink-window-if-larger-than-buffer'."
  (let ((existing-window (get-buffer-window buffer)))
    (message "existing %S" existing-window)
    (condition-case nil
        ;; emacs two args
        (switch-to-buffer-other-window buffer t) ;; no-record
      (error
       ;; xemacs one arg
       (switch-to-buffer-other-window buffer)))
    (if (not existing-window)
        (shrink-window-if-larger-than-buffer (get-buffer-window buffer)))))

