;; Copyright 2009, 2010, 2012, 2014 Kevin Ryde

;; my-unload.el is shared by several distributions.
;;
;; my-unload.el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; my-unload.el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with my-unload.el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;; Code:

(defconst my-unload-feature-function-p
  (if (string-match "FEATURE-unload-function"
                    (documentation 'unload-feature))
      t
    nil)
  "t if `unload-feature' looks for a `FEATURE-unload-function'.
This is so in Emacs 22 and up.")

(defun my-advice-by-name (name)
  (and (boundp 'ad-advised-functions)
       (let (ret)
         (mapcar (lambda (elem)
                   (let ((symbol (intern (car elem))))
                     (mapcar (lambda (class)
                               (if (ad-find-advice symbol class name)
                                   (setq ret (cons (list symbol class name)
						   ret))))
                             ad-advice-classes)))
                 ad-advised-functions)
         ret)))

;; (my-advice-by-name 'quick-yes)

(provide 'my-unload)

;;; my-unload.el ends here
