;; Copyright 2009, 2010, 2014 Kevin Ryde

;; This file is part of weblint-el.
;;
;; weblint-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; weblint-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with weblint-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(add-to-list 'load-path (expand-file-name ".."))
(eval-after-load "compile" '(require 'compilation-weblint))

(defun my-run-test ()
  (let ((count 0))

    ;; check the autoload cookie eval-after-load
    (require 'compile)
    (or (featurep 'compilation-weblint)
	(error "compilation-weblint.el not autoloaded with compile.el"))
    (setq count (1+ count))

    ;;----------------------------

    (add-to-list 'load-path (expand-file-name "."))
    (require 'my-compile-testing)

    (my-compilation-validate-alists)

    (find-file "t-compilation-weblint.txt")
    (compilation-mode)
    (let ((got  (my-compilation-error-lines))
	  (want '((24 "d-compilation-weblint.html" 2)
		  (25 "d-compilation-weblint.html" 33)
		  (26 "d-compilation-weblint.html" 35)
		  (27 "d-compilation-weblint.html" 36)
		  (28 "d-compilation-weblint.html" 38))))
      (unless (equal got want)
        (require 'pp) ;; not pre-loaded in emacs21
        (error "wrong error lines: got\n%s\nwant\n%s"
               (pp-to-string got)
               (pp-to-string want))))
    (kill-buffer nil)
    (setq count (1+ count))

    ;;----------------------------

    (message "  %d tests" count)
    count))
